#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

long long n, m, k, LS, glkil;
vector <vector <long long> > P;
vector <long long> Suf;

long long Imp(string str, long long x){
    long long sum = 0;

    for (long long i = 0; i<str.size(); i++){
        sum += P[i+x][str[i] - 'a'];
    }

    return sum;
}

long long H(long long x){
    return lower_bound(Suf.begin(), Suf.end(), x) - Suf.begin();
}

long long F(long long x){
    long long counter = 0;
    long long kil = glkil;
    long long now, sum;
    string str;

    for (long long i = 0; i<kil; i++){
        str = "";
        now = i;
        for (long long j = 0; j<m-LS; j++){
            str += ('a' + now%n);
            now /= n;
        }
        sum = Imp(str, 0);
        counter += Suf.size() - H(x - sum);
    }

    return counter;
}

long long G(long long x, string str){
    long long counter = 0;
    long long now, sum, kil;
    string buf;

    if (str.size() + LS > m){
        long long sumpr = Imp(str, 0);
        kil = pow(n, m - str.size());

        for (long long i = 0; i<kil; i++){
            buf = "";
            now = i;
            for (long long j = 0; j<m - str.size(); j++){
                buf += ('a' + now%n);
                now /= n;
            }
            sum = Imp(buf, str.size());
            if (sum + sumpr == x) counter++;
        }
    } else {
        long long sumpr = Imp(str, 0);
        kil = pow(n, m - LS - str.size());

        for (long long i = 0; i<kil; i++){
            buf = "";
            now = i;
            for (long long j = 0; j<m - LS - str.size(); j++){
                buf += ('a' + now%n);
                now /= n;
            }
            sum = sumpr + Imp(buf, str.size());
            counter += H(x - sum + 1) - H(x - sum);
        }
    }

    return counter;
}

int main(){
    freopen("aliens.in", "r", stdin);

    long long A = 0, B = 0, locmin, locmax;

    scanf("%d%d%d", &n, &m, &k);

    P.resize(m);
    for (long long i = 0; i<m; i++){
        P[i].resize(n);
        locmin = 1000000000;
        locmax = 0;
        for (long long j = 0; j<n; j++){
            scanf("%d", &P[i][j]);
            locmin = min(locmin, P[i][j]);
            locmax = max(locmax, P[i][j]);
        }
        A += locmin;
        B += locmax;
    }

    /**SUPPORT**/

    LS = (m+1)/2;
    long long kil = pow(n, LS);
    glkil = pow(n, m - LS);
    long long now, sum;
    string str, buf;

    for (long long i = 0; i<kil; i++){
        str = "";
        now = i;
        for (long long j = 0; j<LS; j++){
            str += ('a' + now%n);
            now /= n;
        }
        sum = Imp(str, m-LS);
        Suf.push_back(sum);
    }
    sort(Suf.begin(), Suf.end());

    /**MAIN PART**/

    while (B - A > 1){
        long long C = (A+B)>>1;
        if (F(C) < k) B = C; else A = C;
    }

    string s = "";
    long long L = k - F(B), L1 = 0;

    while (s.size() < m){
        for (char i = 'a'; i<'a'+n; i++){
            buf = i;
            long long now = G(A, s+buf);
            if (L1 + now < L){
                L1 += now;
            } else {
                s = s+buf;
                break;
            }
        }
    }

    freopen("aliens.out", "w", stdout);
    for (long long i = 0; i<m; i++) printf("%c", s[i]); printf("\n");


    return 0;
}
