/* GCC */
#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <cmath>
#include <stdio.h>
#include <set>

using namespace std;

#define fast ios_base::sync_with_stdio(false);cin.tie(false);cout.tie(false)
#define endl '\n'
#define file(s) freopen(s ".in", "r", stdin); freopen(s ".out", "w", stdout);

typedef long long ll;

vector <pair<unsigned long long, string> > q;
unsigned long long n, m;
vector <vector <unsigned long long> > ball;

void rec(string s, unsigned long long st){
    if (s.size() == n) {
        q.push_back(make_pair(st,s));
        return;
    }
    for (int i = 0; i < m; i++){
        s += char(i) + 'a';
        rec(s, st + ball[s.size() - 1][i]);
        s.erase(s.end() - 1);
    }
}

int main(){
    file("aliens");
    fast;
    unsigned long long k;
    cin >> m >> n >> k;
    ball.assign(n, vector <unsigned long long> (m));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> ball[i][j];
    rec("",0);
    sort(q.begin(),q.end());
    cout << q[k-1].second << '\n';
}
