#include<iostream>
#include<cstdio>

using namespace std;

int t, n, arr[100000];

int a = 35521, m = 28768;

int left_hash[100000][2];
void gen_left(){
    int power = 1;
    for(int i = 1; i < n; ++i){
        left_hash[i][0] = (left_hash[i-1][0] + arr[i] * power) % m;
        left_hash[i][1] = (arr[i] + left_hash[i-1][1] * a) % m;
        power = power * a % m;
    }
}

int right_hash[100000][2];
void gen_right(){
    int power = 1;
    for(int i = 1; i < n; ++i){
        right_hash[i][0] = (right_hash[i-1][0] + arr[n-i] * power) % m;
        right_hash[i][1] = (arr[n-i] + right_hash[i-1][1] * a) % m;
        power = power * a % m;
    }
}

bool check(int pos){
    for(int i = 1; i < pos; ++i)
        if(arr[i] != arr[pos - i])
            return false;
    for(int i = pos+1; i < n; ++i)
        if(arr[i] != arr[n + pos - i])
            return false;
    return true;
}

int main(){
    freopen("symmetry.in", "r", stdin);
    freopen("symmetry.out", "w", stdout);
    cin >> t;
    for(int k = 0; k < t; ++k){
        cin >> n;
        for(int i = 0; i < n; ++i)
            cin >> arr[i];
        for(int i = n-1; i >= 1; --i)
            arr[i] -= arr[i-1];
        gen_left();
        gen_right();
        bool found = false;
        for(int i = 0; i < n-1; ++i){
            if(left_hash[i][0] == left_hash[i][1])
                if(right_hash[n-i-2][0] == right_hash[n-i-2][1])
                    if(check(i+1)){
                        found = true;
                        cout << i+1 << endl;
                        break;
                    }
        }
        if(!found)
            cout << 0 << endl;
    }
}
