#include <iostream>
#include <cstdio>

using namespace std;

typedef long long ll;

const int Nmax = 1e5+1, mod = 1e9+7, p = 41;

ll arr[Nmax], hesh_front[Nmax], hesh_back[Nmax], p_pow[Nmax];

int main()
{
    freopen("symmetry.in", "r", stdin);
    freopen("symmetry.out", "w", stdout);

    int n, t;
    scanf("%d", &t);
    while(t--) {
        scanf("%d", &n);
        bool ans = false;
        int prev, cur;
        scanf("%d", &prev);
        n--;
        for(int i = 0;i < n;++i) {
            scanf("%d", &cur);
            arr[i] = cur - prev;
            prev = cur;
        }

        hesh_front[0] = arr[0];
        hesh_back[n-1] = arr[n-1];
        p_pow[0] = 1;
        for(int i = 1;i < n;++i) {
            p_pow[i] = p_pow[i-1] * p % mod;
            hesh_front[i] = (p_pow[i] * arr[i] + hesh_front[i-1]) % mod;
            hesh_back[n-i-1] = (p_pow[i] * arr[n-i-1] + hesh_back[n-i]) % mod;
        }

        for(int i = 0;i < n;++i) {
            if((i == 0 || hesh_front[i-1]*p_pow[n-i] % mod == (hesh_back[0] - hesh_back[i] + mod) % mod) &&
               (i == n-1 || hesh_back[i+1]*p_pow[i+1] % mod == (hesh_front[n-1] - hesh_front[i] + mod) % mod)) {
               printf("%d\n", i+1);
               ans = true;
               break;
            }
        }
        if(!ans)
            printf("0\n");
    }
    return 0;
}
