/*GCC */
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cstdio>

using namespace std;

long long A[20][20];
long n,m,k;
map <vector <long>,bool> used;

long long CountSum(vector <long> mask){
    long long r = 0;
    for (long i = 0;i < n;i++)r += A[i][mask[i]];
    return r;
}

long long Less(long long k,vector <long> mask,long long sum){
    if (used[mask]) return 0;
    used[mask] = 1;
   //for (long i = 0;i < n;i++)cout << mask [i] << ' ';
   // cout << '\n';
    long long r = 0ll;
    if (sum < k) r++;
    else return 0;
    for (long i = 0;i < n;i++){
        if (mask[i]<m-1&&sum - A[i][mask[i]] + A[i][mask[i]+1] < k){
            mask[i]++;
            if (!used[mask])r += Less(k,mask,sum - A[i][mask[i]-1] + A[i][mask[i]]);
            mask[i]--;
        }
    }
    return r;
}

vector <long> mask;

long BinPow()
{
    long long l = 0,r = (16ll*100ll*1000ll*1000ll);
    mask.assign(n,0);
    long long cnst = CountSum(mask);
    while(r-l>1){
        long long mid = (l + r)/2ll;
    //cout << mid << '\n';
        used.clear();
        long temp = Less(mid,mask,cnst);
        //cout << mid << ' ' << temp << '\n';
        if (temp < k) l = mid;
        else r = mid;
        //cout << l << ' '<< r << '\n' << '\n';
    }
    return l;
}

long long FindAns(long long k,vector <long> mask,long long sum)
{
        if (used[mask]) return 0;
    used[mask] = 1;
   //for (long i = 0;i < n;i++)cout << mask [i] << ' ';
   // cout << '\n';
    long long r = 0ll;
    if (sum < k) r++;
    else return 0;
    for (long i = 0;i < n;i++){
        if (mask[i]<m-1&&sum - A[i][mask[i]] + A[i][mask[i]+1] < k){
            mask[i]++;
            if (!used[mask])r += Less(k,mask,sum - A[i][mask[i]-1] + A[i][mask[i]]);
            mask[i]--;
        }else{
            if (sum - A[i][mask[i]] + A[i][mask[i]+1] == k){
                mask[i]++;
                for (long i = 0;i < n;i++)
                    cout << 'a' + mask[i];
                cout << '\n';
                exit(0);
            }
        }
    }
    return r;
}


int main()
{
    freopen("aliens.in","r",stdin);
    freopen("aliens.out","w",stdout);
    cin >> n >> m >> k ;
    for (long i = 0;i < n;i++)
        for (long j = 0;j < m;j++)
        cin >> A[i][j] ;
        used.clear();
    for (long i = 0;i < n;i++)
        sort(A[i],A[i]+m);
        mask.assign(n,0);
    used.clear();
    long long AnsSum = BinPow();
    FindAns(AnsSum,mask,CountSum(mask));
    return 0;
}
