#include <iostream>
#include <cmath>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

long long v[11][17];

int sum, cur, n, m, i, j, M, k, x, l, r, L;

vector <int> lef, righ;

void genl(int pos, int sum) {
    if(pos == M) {
        lef.push_back(sum);
        return;
    }

    for(int i = 0; i < n; i++)
        genl(pos + 1, sum + v[pos][i]);
}

void genr(int pos, int sum) {
    if(pos == m) {
        righ.push_back(sum);
        return;
    }

    for(int i = 0; i < n; i++)
        genr(pos + 1, sum + v[pos][i]);
}

void g1(int pos, int sum) {
    if(x - sum + 1 < 0) return;
    if(pos == M) {
        cur += (lower_bound(righ.begin(), righ.end(), x - sum + 1) - lower_bound(righ.begin(), righ.end(), x - sum));
        return;
    }

    for(int i = 0; i < n; i++)
        g1(pos + 1, sum + v[pos][i]);
}

void g2(int pos, int sum) {
    if(x - sum < 0) return;

    if(pos == m) {
        if(sum == x) cur++;
        return;
    }

    for(int i = 0; i < n; i++)
        g2(pos + 1, sum + v[pos][i]);
}

int main() {
    freopen("aliens.in", "r", stdin);
    freopen("aliens.out", "w", stdout);
    cin >> n >> m >> k;

    for(int i = 0; i < m; i++)
        for(int j = 0; j < n; j++)
            cin >> v[i][j];

    M = m - (m / 2);
    genl(0, 0);
    genr(M, 0);

    /*
    for(int i = 0; i < lef.size(); i++)
        cout << lef[i] << ' ';
    cout << endl;
    for(int i = 0; i < righ.size(); i++)
        cout << righ[i] << ' ';
    */

    sort(lef.begin(), lef.end());
    sort(righ.begin(), righ.end());

    l = lef.back() + righ.back();
    r = lef[0] + righ[0] - 1;

    while(l - r > 1) {
        int mid = (l + r) / 2;
        cur = 0;

        for(int i = 0; i < lef.size(); i++)
            cur += (righ.size() - (lower_bound(righ.begin(), righ.end(), mid - lef[i] + 1) - righ.begin()));

        if(k <= cur) r = mid;
        else l = mid;
    }

    // << l << endl;

    for(int i = 0; i < lef.size(); i++)
        k -= (righ.size() - (lower_bound(righ.begin(), righ.end(), l - lef[i] + 1) - righ.begin()));

    //cout << "k = " << k << endl;

    L = 0;
    sum = 0;
    //sum = 0;
    x = l;
    string ans = "";
    while(L < m) {
        for(int i = 0; i < n; i++) {
            cur = 0;
            sum += v[L][i];

            if(L < M) g1(L + 1, sum);
            else g2(L + 1, sum);

            //cout << ((char)(i + 'a')) << ' ' << cur << ' ' << k << endl;

            if(cur < k) k -= cur;
            else {
                ans += (i + 'a');
                break;
            }
            sum -= v[L][i];
        }
        //cout << L << endl;
        L++;
    }
    cout << ans << '\n';
}
