#include <iostream>
#include <cmath>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>

#define MAXN 100010

using namespace std;

long long d[MAXN], gl[MAXN], gr[MAXN], hl[MAXN], hr[MAXN];
long long n, a, am, m = 10e9 + 7;

int main() {
    freopen("symmetry.in", "r", stdin);
    freopen("symmetry.out", "w", stdout);

    long long test;
    cin >> test;
    while(test--) {
        long long a = 3;

        cin >> n;

        long long b, c;
        cin >> b;
        for(int i = 1; i < n; i++) {
            cin >> c;
            d[i] = c - b;
            b = c;
        }

        //for(int i = 1; i < n; i++) cout << d[i] << ' '; cout << endl;

        gl[0] = hl[0] = 1;
        am = a;
        for(int i = 1; i < n; i++) {
            gl[i] = (gl[i - 1] + ((d[i] * am) % m)) % m;
            hl[i] = (hl[i - 1] * a + (d[i] % m)) % m;
            am = am * a;
        }

        gr[n] = hr[n] = 1;
        am = a;
        for(int i = n - 1; i >= 1; i--) {
            gr[i] = (gr[i + 1] + ((d[i] * am) % m)) % m;
            hr[i] = (hr[i + 1] * a + (d[i] % m)) % m;
            am = am * a;
        }
        int i;
        for(i = 1; i < n; i++) {
                //cout << gl[i] << ' ' << hl[i] << ' ' << gr[i] << ' ' << hr[i] << endl;
            if(gl[i] == hl[i] && gr[i] == hr[i]) {
                bool sym = true;

                for(int j = 1; j <= (i / 2); j++)
                    if(d[j] != d[i - j]) sym = false;

                //cout << sym << endl;

                for(int j = 1; j < (n - i) / 2; j++)
                    if(d[i + j] != d[n - j]) sym = false;

                //cout << sym << endl;

                if(sym == true) {
                    cout << i << '\n';
                    break;
                }
            }
        }
        if(i == n) cout << "0\n";
    }
}

