#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;

int main(){
    freopen("symmerty.in", "r", stdin);
    freopen("symmerty.out", "w", stdout);

    long long b1, b2, b3, b4, st1, st2, p1 = 10007, p2 = 9999991, p3 = 10009, p4 = 10000019;
    int n, t;
    vector <int> A;
    vector <bool> B;

    scanf("%d", &t);

    while (t--){
        scanf("%d", &n);
        A.resize(n); B.assign(n, false);
        for (int i = 0; i<n; i++) scanf("%d", &A[i]);
        for (int i = 0; i<n-1; i++) A[i] = A[i+1] - A[i];
        //for (int i = 0; i<n-1; i++) printf("%d ", A[i]); printf("\n");

        b1 = b2 = b3 = b4 = 0;
        st1 = st2 = 1;

        for (int i = n-1; i > 0; i--){
            B[i] = ((b1 == b2) && (b3 == b4));

            b1 = (b1*p1 + A[i-1]) % p2;
            b2 = (b2 + st1*A[i-1]) % p2;
            st1 = (st1*p1) % p2;

            b3 = (b3*p3 + A[i-1]) % p4;
            b4 = (b4 + st2*A[i-1]) % p4;
            st2 = (st2*p3) % p4;
        }
        //for (int i = 0; i<n; i++) if (B[i]) printf("1 "); else printf("0 "); printf("\n");

        bool p = false;
        b1 = b2 = b3 = b4 = 0;
        st1 = st2 = 1;

        for (int i = 0; i<n-1; i++){
            if (B[i+1] && (b1 == b2 && b3 == b4)){
                printf("%d\n", i+1);
                p = true;
                break;
            }

            b1 = (b1*p1 + A[i]) % p2;
            b2 = (b2 + st1*A[i]) % p2;
            st1 = (st1*p1) % p2;

            b3 = (b3*p3 + A[i]) % p4;
            b4 = (b4 + st2*A[i]) % p4;
            st2 = (st2*p3) % p4;
        }

        if (!p) printf("0\n");

    }

    return 0;
}
