#include <iostream>
#include <algorithm>
#include <vector>
#include <cstdio>

using namespace std;

typedef long long ll;

struct hS {
    int pr;
    string s;
};

bool operator<(hS a, hS b) {
    if(a.pr == b.pr)
        return a.s < b.s;
    return a.pr > b.pr;
}

int arr[10][16];

vector<hS> ans;

ll pr = 0;
int m, n;
string str;
void make_words(int k = 0) {
    if(k == m) {
        ans.push_back({pr, str});
        return;
    }

    for(int i = 0;i < n;++i) {
        str[k] = i+'a';
        pr += arr[k][i];
        make_words(k+1);
        pr -= arr[k][i];
    }
}

int main()
{

    freopen("aliens.in", "r", stdin);
    freopen("aliens.out", "w", stdout);

    int k;
    scanf("%d %d %d", &n, &m, &k);

    for(int i = 0;i < m;++i) {
        for(int j = 0;j < n;++j) {
            scanf("%d", &arr[i][j]);
        }
    }
    for(int i = 0;i < m;++i)
        str+= 'a';
    make_words();
    sort(ans.begin(), ans.end());
    cout << ans[k-1].s << '\n';
    return 0;
}
