/* GCC */
#include <bits/stdc++.h>
#define files(x) freopen(#x".in", "r", stdin); \
                 freopen(#x".out", "w", stdout)

using namespace std;
typedef long long lint;
typedef pair<int, int> pii;
const lint inf = 1000*1000*1000 + 7;

struct word {
    string s;
    int imp;
    word(const string& s, int imp): s(s), imp(imp) {}
};

inline bool operator<(const word& a, const word& b) {
    return a.imp > b.imp || a.imp == b.imp && a.s < b.s;
}

inline bool comp(const pii& a, const pii& b) {
    return a.first < b.first || a.first == b.first && a.second > b.second;
}

pii p[10][16];
int inv[10][16];
int n, m;
set<word> dict;

void add(const word& w) {
    string t = w.s;
    for (int i = 0; i < m; i++) {
        int ind = inv[i][w.s[i]-'a'];
        if (ind == 0) continue;
        t[i] = 'a' + p[i][ind-1].second;
        int imp = w.imp - p[i][ind].first + p[i][ind-1].first;
        dict.insert(word(t, imp));
        t[i] = w.s[i];
    }
}

int main() {

    files(aliens);
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

    int k;
    cin >> n >> m >> k;

    for (int i = 0; i < m; i++)
        for (int j = 0; j < n; j++)
            cin >> p[i][j].first,
            p[i][j].second = j;

    for (int i = 0; i < m; i++)
        sort(p[i], p[i]+n, comp);

    for (int i = 0; i < m; i++)
        for (int j = 0; j < n; j++)
            inv[i][p[i][j].second] = j;

    string largest;
    int imp = 0;
    for (int i = 0; i < m; i++) {
        largest.push_back('a'+p[i][n-1].second);
        imp += p[i][n-1].first;
    }

    dict.insert(word(largest, imp));
    for (int i = 0; i < k-1; i++) {
        word w = *dict.begin();
        dict.erase(w);
        add(w);
    }

    cout << dict.begin()->s << '\n';

    return 0;
}

