/* GCC */
#include <bits/stdc++.h>
#define files(x) freopen(#x".in", "r", stdin); \
                 freopen(#x".out", "w", stdout)

using namespace std;
typedef long long lint;
const lint inf = 1000*1000*1000 + 7;
const int total = 100000;

int diff[total], powers[total],
    frw[total], bck[total], n;

bool pal(int i, int j) {
    lint h1 = (frw[j] - frw[i-1] + inf) % inf;
    lint h2 = (bck[n-i+1] - bck[n-j] + inf) % inf;
    h1 = h1*powers[total-j] % inf;
    h2 = h2*powers[total-(n-i+1)] % inf;
    return h1 == h2;
}

int main() {

    files(symmetry);
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

    bck[0] = frw[0] = 0;
    powers[0] = 1;
    for (int i = 1; i < total; i++)
        powers[i] = (lint)powers[i-1]*37 % inf;

    int t, pr, cur;
    cin >> t;

    while (t--) {

        cin >> n >> pr;
        n--;

        for (int i = 0; i < n; i++) {
            cin >> cur;
            diff[i] = cur - pr;
            pr = cur;
        }

        for (int i = 0; i < n; i++) {
            frw[i+1] = ((lint)diff[i]*powers[i] + frw[i]) % inf;
            bck[i+1] = ((lint)diff[n-i-1]*powers[i] + bck[i]) % inf;
        }

        bool flag = 0;
        for (int i = 0; i < n; i++) {
            if (pal(1, i) && pal(i+2, n)) {
                cout << i+1 << '\n';
                flag = 1;
                break;
            }
        }

        if (!flag) cout << "0\n";

    }

    return 0;
}
