#include <cstdio>
#include <iostream>
#include <vector>
using namespace std;

int main(){
    freopen("symmetry.in", "r", stdin);
    freopen("symmetry.out", "w", stdout);

    long long p1 = 991, p2 = 1000003, p3 = 997, p4 = 1000033;
    long long t;
    cin >> t;
    long long n;
    vector<long long> A;
    vector<bool> B;
    while(t--){
        A.clear(); B.clear();
        cin >> n;
        A.resize(n+2); B.resize(n+2);

        for(long long i = 0; i < n; i++) cin >> A[i];
        for(long long i = 0; i < n-1; i++) A[i] = A[i+1] - A[i];

        long long b1 = 0, b2 = 0, b3 = 0, b4 = 0, st = 1, st1 = 1;

        for(long long i = n-1; i > 0; i--){
            if (b1 == b2 && b3 == b4) B[i] = true; else B[i] = false;
            b1 = (b1*p1 + A[i-1]) % p2;
            b2 = (b2 + st*A[i-1]) % p2;
            st = (st*p1) % p2;
            b3 = (b3*p3 + A[i-1]) % p4;
            b4 = (b4 + st1*A[i-1]) % p4;
            st1 = (st1*p3) % p4;
        }
        bool f = true;
        b1 = 0; b2 = 0; b3 = 0; b4 = 0; st = 1; st1 = 1;

        for(long long i = 0; i < n-1; i++){
            if ((b1 == b2 && b3 == b4) && (B[i+1])) {cout << i+1 << "\n"; f = false; break;}
            b1 = (b1*p1 + A[i]) % p2;
            b2 = (b2 + st*A[i]) % p2;
            st = (st*p1) % p2;
            b3 = (b3*p3 + A[i]) % p4;
            b4 = (b4 + st1*A[i]) % p4;
            st1 = (st1*p3) % p4;
        }
        if (f) cout << "0\n";
    }

    fclose(stdin);
    return 0;
}
